from netgen.csg import *
from ngsolve import *

geo = CSGeometry()
br1 = OrthoBrick (Pnt(0,0,0), Pnt(1,1,1))
br2 = OrthoBrick (Pnt(0.2,0.2,0.2), Pnt(0.8, 0.8, 0.8))
geo.Add (br2.mat("inner"))
geo.Add ( (br1-br2).mat("outer") )

mesh = Mesh(geo.GenerateMesh(maxh=0.3))
fes = L2(mesh, order=2)

gfu = GridFunction(fes)
gfu.Set(x*y)

bfv = BoundaryFromVolumeCF(gfu)
Draw (bfv, mesh, "u_on_surface")


func_domain2 = CoefficientFunction ([None, specialcf.normal(3)] )
bfv2 = BoundaryFromVolumeCF(func_domain2)
Draw (bfv2, mesh, "normal-vec_from_domain_2")



